﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Private ivBackground As B4XView
	Public lblStats As B4XView
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	
	Private arrow As X2BodyWrapper
	Private p(10),gotoNow As X2BodyWrapper
	Dim pointNo As Int = 0
	
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GameLayout")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
	Dim WorldWidth As Float = 6 'meters
	Dim WorldHeight As Float = WorldWidth / 1.333 'same ratio as in the designer script
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 2, WorldHeight / 2), WorldWidth)
	'remove if not using Tiled:
	TileMap.Initialize(X2, File.DirAssets, "path.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldWidth / TileMap.TilesPerRow, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	'comment to disable debug drawing
	X2.EnableDebugDraw
	
	loadBodies
	gotoNow = p(1)
	pointNo = 1
End Sub

Sub loadBodies	
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		Select template.Name
			Case "arrow"
				arrow = TileMap.CreateObject(template)
			Case "p1"
				p(1) = TileMap.CreateObject(template)
				
			Case "p2"
				p(2) = TileMap.CreateObject(template)
				
			Case "p3"
				p(3) = TileMap.CreateObject(template)
				
			Case "p4"
				p(4) = TileMap.CreateObject(template)
	
			Case "p5"
				p(5) = TileMap.CreateObject(template)
				
			Case "p6"
				p(6) = TileMap.CreateObject(template)
				
			Case "p7"
				p(7) = TileMap.CreateObject(template)
				
			Case "p8"
				p(8) = TileMap.CreateObject(template)

			Case "p9"
				p(9) = TileMap.CreateObject(template)
												
			Case Else
				Dim bwC As X2BodyWrapper
				bwC = TileMap.CreateObject(template)
				bwC.TimeToLiveMs = 0
				'bwC.Body.FirstFixture.SetFilterBits(0, 0)
				'TileMap.GetObjectTemplateByName
		End Select
	Next
	
End Sub

Public Sub Tick (GS As X2GameStep)
	FoloowPath
End Sub

Private Sub FoloowPath
	
	Dim v As B2Vec2 = gotoNow.Body.Position.CreateCopy
	v.SubtractFromThis(arrow.Body.Position)
	
	If v.Length > 0.03 Then
		v.NormalizeThis
		
		'v.MultiplyThis(1.5)   ' To control speed, use this variable
		
		arrow.Body.LinearVelocity = v
		arrow.Body.SetTransform(arrow.Body.Position, ATan2(v.Y, v.X) + cPI / 1)
	Else
		arrow.Body.LinearVelocity = X2.CreateVec2(0, 0)
		
		If pointNo = 9 Then 
			Log("End")
		Else 
			gotoNow = p(pointNo + 1)
			pointNo = pointNo + 1
			
		End If
		
	End If
	
End Sub
Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	
End Sub

'Return True to stop the game loop.
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub


